

function init(self)
	self.StartingX = self.X
	self.StartingY = self.Y
	self.Flags.AlwaysActive = true
end

function main(self)
	if self.State == 0 then
		self.State = 1
		self:SetImage("LEVEL ELEVATORS")
		self.HitRect = {-44, -8, 46, 64}
		self.ObjectTypeFlags = ObjectType.Special
	end

	local claw = GetClaw()

	if self.State > 0 and claw.Health == 0 then
		self.State = 0
		self.X = self.StartingX
		self.Y = self.StartingY
		self.MoveClawX = 0
		self.MoveClawY = 0
		do return end
	end
	
	if self.State == 1 and self:IsBelow(GetClaw()) then
		self.State = 2
	end
	
	if self.State == 2 then
		
		if self.X + self.SpeedX >= self.XMin then
			self.MoveClawX = 0
			self.State = 3
		else
			self.X = self.X + self.SpeedX
			self.MoveClawX = self.SpeedX
		end
	end
	
	if self.State == 3 then	
		if self.Y - self.SpeedY <= self.YMin then
			self.MoveClawY = 0
			self.State = 4
		else
			self.MoveClawY = - self.SpeedY
			self.Y = self.Y - self.SpeedY
		end
		
	end
	
	if self.State == 4 and not self:IsBelow(GetClaw()) then
		self.State = 5
	end
	
	if self.State == 5 and self:IsBelow(GetClaw()) then
		self.State = 6
	end
	
	
	
	if self.State == 6 then
	
		local ReachedY = self.Y + self.SpeedY >= self.YMax
		local ReachedX = self.X + self.SpeedX >= self.XMax
	
		if ReachedX and ReachedY then
			self.MoveClawY = 0
			self.MoveClawX = 0
			self.State = 7
			do return end
		end
		
		if ReachedY then
			self.MoveClawY = 0
		else
	
			self.Y = self.Y + self.SpeedY
		
			self.MoveClawY = self.SpeedY
		end
		
		if ReachedX then
			self.MoveClawX = 0
		else
			local oldX = self.X
			self.X = self.X + self.SpeedX
			self.MoveClawX = self.SpeedX
		end
		
	end

end
